/*
 WMMListBox.h
 Copyright (C) 1998-1999 R. Michael Sharkey (msharkey@canada.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <errno.h>

#include <qapp.h>
#include <qlistbox.h>
#include <qfile.h>
#include <qtstream.h>
#include <qmsgbox.h>
#include <qstring.h>
#include <qlist.h>

#define SYSXWMMRC "/usr/X11R6/lib/X11/xwmm/system.xwmmrc"

extern QApplication *gApp;

class WMMListBox : public QListBox
{
    Q_OBJECT;
public:
    WMMListBox( QWidget *parent=0, const char *name=0, WFlags f=0 );
    ~WMMListBox();
    bool           save( void );
    bool           load( void );
public slots:
    void           activate();
    void           stopTimer();
    void           newEntry();
    void           deleteEntry();
    void           reviseEntry();
    void           reviseProperties();
signals:
    void           sigHide();
    void           sigShow();
    void           tick( int );
    void           timeout();
protected:
    void           timerEvent( QTimerEvent *e );
    void           mousePressEvent( QMouseEvent *e );
    void           mouseReleaseEvent( QMouseEvent *e );
    void           mouseDoubleClickEvent( QMouseEvent *e );
    void           keyPressEvent( QKeyEvent *e );
private:
    bool           setAccessControl( void );
    bool           readStream( QTextStream *stream );
    bool           saveProperties( QFile *file );
    bool           saveEntries( QFile *file );
    bool           backup( QFile *file );
    void           initTimer( void );
    bool           activeTimer( void );
    bool           repeat;
    int            timerID;
    int            timerVal;
    int            launchDelay;
    int            defaultIndex;
    QList<QString> commandLines;
    QList<QString> allowList;
    QList<QString> disallowList;
};
