/*
 WindowManagerManager.h
 Copyright (C) 1998-1999 R. Michael Sharkey (msharkey@canada.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <errno.h>

#include <qapp.h>
#include <qwidget.h>
#include <qlistbox.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qlist.h>
#include <qlabel.h>
#include <qmsgbox.h>
#include <qpushbt.h>
#include <qpainter.h>
#include <qdrawutil.h>
#include <qcolor.h>

#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qkeycode.h>

#include <qfiledialog.h>

#include <WMMListBox.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>

#define WMM_VERSION "xwmm 0.7"

extern QApplication *gApp;

class WindowManagerManager : public QWidget
{
    Q_OBJECT;
public:
    WindowManagerManager( QWidget *parent=NULL, const char *name=0, WFlags wf=0 );
    ~WindowManagerManager();
public slots:
    void           menuBarActive(int);
    void           tick( int );
    void           newEntry();
    void           deleteEntry();
    void           reviseEntry();
    void           reviseProperties();
    void           aboutWMM();
protected:
    virtual void   enterEvent( QEvent *e );
    virtual void   leaveEvent( QEvent *e );
    virtual void   paintEvent( QPaintEvent *e );
private:
    QMenuBar       *pMenuBar;
    WMMListBox     *pListBox;
    QLabel         *pIcon;
    QLabel         *pTitle;
    QPushButton    *pCloseButton;
};
