/*
 entryForm.cpp
 Copyright (C) 1998-1999 R. Michael Sharkey (msharkey@canada.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/**********************************************************************

	--- Qt Architect generated file ---

	File: entryForm.cpp
	Last generated: Thu May 27 19:56:28 1999

 *********************************************************************/

#include "entryForm.h"

#define Inherited entryFormData

entryForm::entryForm
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
	setCaption( "Window Manager" );
        connect( this, SIGNAL(fileSelected(const char *)), commandLineEditor, SLOT(setText(const char *)) );
}


entryForm::~entryForm()
{
}

void entryForm::setTitleText( const char *title )
{
    titleEditor->setText( title );
}

void entryForm::setCommandLineText( const char *commandLine )
{
    commandLineEditor->setText( commandLine );
}

void entryForm::setDefault( bool def )
{
    defaultCheckBox->setChecked( def );
}

const char * entryForm::getTitleText()
{
    return titleEditor->text();
}

const char * entryForm::getCommandLineText()
{
    return commandLineEditor->text();
}

bool entryForm::getDefault()
{
    return defaultCheckBox->isChecked();
}


void entryForm::browse()
{
    QString fileName = QFileDialog::getOpenFileName( 0, "*", this );
    if ( !fileName.isEmpty() )
        emit fileSelected( fileName.data() );
}

void entryForm::enterEvent( QEvent *e )
{
    Inherited::enterEvent( e );
    XSetInputFocus( qt_xdisplay(), winId(), RevertToParent, CurrentTime );
}

void entryForm::leaveEvent( QEvent *e )
{
    Inherited::leaveEvent( e );
}

void entryForm::paintEvent( QPaintEvent *e )
{
    Inherited::paintEvent( e );
    QPainter paint( this );
    QRect bounds = rect();
    qDrawShadePanel( &paint,
                     bounds.x(), bounds.y(), bounds.width(), bounds.height(),
                     colorGroup() );


}
