/*
 propertiesForm.cpp
 Copyright (C) 1998-1999 R. Michael Sharkey (msharkey@canada.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**********************************************************************

	--- Qt Architect generated file ---

	File: propertiesForm.cpp
	Last generated: Thu May 27 22:40:41 1999

 *********************************************************************/

#include "propertiesForm.h"

#define Inherited propertiesFormData

propertiesForm::propertiesForm
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
	setCaption( "Properites" );
        QObject::connect(allowAddButton,      SIGNAL(clicked()), this, SLOT(allowAddClicked()) );
        QObject::connect(allowRemoveButton,   SIGNAL(clicked()), this, SLOT(allowRemoveClicked()) );
        QObject::connect(disallowAddButton,   SIGNAL(clicked()), this, SLOT(disallowAddClicked()) );
        QObject::connect(disallowRemoveButton,SIGNAL(clicked()), this, SLOT(disallowRemoveClicked()) );

        QObject::connect(allowEdit,    SIGNAL(returnPressed()), allowAddButton,    SLOT(animateClick()) );
        QObject::connect(disallowEdit, SIGNAL(returnPressed()), disallowAddButton, SLOT(animateClick()) );
}


propertiesForm::~propertiesForm()
{
}

void propertiesForm::setAllow( QList<QString> *list )
{
    pAllowList = list;
    
    for ( int index=0; index < pAllowList->count(); index++ ) {
        allowList->insertItem( pAllowList->at( index )->data() );
    }
}

void propertiesForm::setDisallow( QList<QString> *list )
{
    pDisallowList = list;
    
    for ( int index=0; index < pDisallowList->count(); index++ ) {
        disallowList->insertItem( pDisallowList->at( index )->data() );
    }
}

void propertiesForm::getAllow( void )
{
    pAllowList->clear();
    for ( int index=0; index < allowList->count(); index++ ) {
        QString *item = new QString( allowList->text( index ) );
        pAllowList->append( item );
    }
}

void propertiesForm::getDisallow( void )
{
    pDisallowList->clear();
    for ( int index=0; index < disallowList->count(); index++ ) {
        QString *item = new QString( disallowList->text( index ) );
        pDisallowList->append( item );
    }
}

void propertiesForm::allowAddClicked()
{
    if ( strlen( allowEdit->text() ) ) {
        allowList->insertItem( allowEdit->text() );
        allowEdit->setText( "" );
    }
}

void propertiesForm::allowRemoveClicked()
{
    if ( allowList->currentItem() >=0 ) {
        allowList->removeItem( allowList->currentItem() );
    }
}

void propertiesForm::disallowAddClicked()
{
    if ( strlen( disallowEdit->text() ) ) {
        disallowList->insertItem( disallowEdit->text() );
        disallowEdit->setText( "" );
    }
}

void propertiesForm::disallowRemoveClicked()
{
    if ( disallowList->currentItem() >=0 ) {
        disallowList->removeItem( disallowList->currentItem() );
    }
}

void propertiesForm::enterEvent( QEvent *e )
{
    Inherited::enterEvent( e );
    XSetInputFocus( qt_xdisplay(), winId(), RevertToParent, CurrentTime );
}

void propertiesForm::leaveEvent( QEvent *e )
{
    Inherited::leaveEvent( e );
}

void propertiesForm::paintEvent( QPaintEvent *e )
{
    Inherited::paintEvent( e );
    QPainter paint( this );
    QRect bounds = rect();
    qDrawShadePanel( &paint,
                     bounds.x(), bounds.y(), bounds.width(), bounds.height(),
                     colorGroup() );


}

