/*
 propertiesForm.cpp
 Copyright (C) 1998-1999 R. Michael Sharkey (msharkey@canada.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**********************************************************************

	--- Qt Architect generated file ---

	File: propertiesForm.h
	Last generated: Thu May 27 22:40:41 1999

 *********************************************************************/

#ifndef propertiesForm_included
#define propertiesForm_included

#include "propertiesFormData.h"
#include <qpainter.h>
#include <qdrawutil.h>
#include <qlist.h>
#include <qstring.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>

class propertiesForm : public propertiesFormData
{
    Q_OBJECT

public:

    propertiesForm
    (
        QWidget* parent = NULL,
        const char* name = NULL
    );

    virtual ~propertiesForm();

    void setRepeat( bool enable ) { repeatCheckBox->setChecked( enable ); }
    void setDelay( int delay )    { delaySpinBox->setValue( delay ); }
    void setAllow( QList<QString> * );
    void setDisallow( QList<QString> * );
    bool getRepeat()              { return repeatCheckBox->isChecked(); }
    int  getDelay()               { return delaySpinBox->value(); }
    void getAllow( void );
    void getDisallow( void );
private slots:
    void allowAddClicked();
    void allowRemoveClicked();
    void disallowAddClicked();
    void disallowRemoveClicked();
protected:
    virtual void  enterEvent( QEvent *e );
    virtual void  leaveEvent( QEvent *e );
    virtual void  paintEvent( QPaintEvent *e );
private:
    QList<QString> *pAllowList;
    QList<QString> *pDisallowList;
};
#endif // propertiesForm_included
